// Suggestions
$("ul li a.topic-link, .close-icon").click(function(e){

    e.preventDefault();

    var elemParent = $(this).parent();
    var open       = elemParent.hasClass('open');
    var hiddenBox  = $(this).parent().find('.hidden-content');
    var commentBox = hiddenBox.find('.comments-wrap');
    var categoryId = $(elemParent).data('category-id');

    if ( open === false ) {
        elemParent.toggleClass('open');
        elemParent.find('form').show();
        elemParent.find('textarea').val('');
        elemParent.find('.alert').remove();
    }

    hiddenBox.slideToggle(function(){
        if ( open ) {
            elemParent.toggleClass('open');
        } else {
            loadComments( categoryId );
        }
    });

    if ( !$(this).hasClass('open-icon') ) {
        var yLoc = elemParent.offset().top - 20;
        $("html, body").animate({ scrollTop: yLoc }, 500);
    }
});

$(document).ready(function(){

     $('[data-toggle="tooltip"]').tooltip()

    $("li.voteable .vote-btn").on('click', function(e){
        e.preventDefault();

        var voteDir = 1;
        if ( $(this).hasClass('down') ) {
            voteDir = 0;
        }
        var vote =  {
            id: $(this).closest('.voteable').data('vote-id'),
            text: $(this).closest('.voteable').text(),
            dir: voteDir,
            add: 1
        };
        if ( Cookies.get('vote-'+vote.id) == '1' ) {
            vote.add = 0;
        }

        var voteContainer = $(this).closest('.votes');



        $.ajax({
            type: 'post',
            data: vote,
            dataType: 'json',
            url: '/vote/add',
            success: function(result){
                voteContainer.html('<div class="vote-count-indicator" data-toggle="tooltip" data-placement="top" title="Annettujen äänien määrät"><span class="green">'+result.votes.votes_up+'</span><span class="red">'+result.votes.votes_down+'</span></div>');
                voteContainer.find('.vote-count-indicator').tooltip({
                    delay: { "show": 300, "hide": 100 }
                });
                Cookies.set('vote-'+vote.id, '1');
            }
        });

        Cookies.set('vote-'+vote.id, '1');
    });
});

function slideToSection( section ) {
    if ( typeof section == 'undefined' ) {
        section = 'suggestions';
    }
    var yLoc = $("#"+section).offset().top;
    $("html, body").animate({
        scrollTop: yLoc
    }, 800, "easeInOutCubic");
}

$(".add-comment-btn").click(function(e){
    e.preventDefault();
    var suggestion_id = $(this).data('suggestion-id');
    var comment_text =  $(this).closest('form').find('textarea').val();
    $.ajax({
        type: 'post',
        data: $(this).closest('form').serialize(),
        dataType: 'json',
        url: '/comments/add',
        success: function(result){

            var currentdate = new Date();
            var datetime = "" + currentdate.getDate() + "."
                + (currentdate.getMonth()+1)  + "."
                + currentdate.getFullYear() + " - "
                + currentdate.getHours() + ":"
                + currentdate.getMinutes();
            $("li.suggestion-"+suggestion_id).find(".comments-wrap form").hide();
            $("li.suggestion-"+suggestion_id).find(".comments").prepend( '<div class="col-md-12 comment"><span class="comment-time">' + datetime + '</span>' + comment_text + '</div>' );
            $("li.suggestion-"+suggestion_id).find(".comments").prepend( '<div class="alert alert-success"><strong>Kiitos!</strong> Kommenttisi tallennettiin onnistuneesti.</div>' );
        }
    });
});


function loadComments( suggestion_id, page, offset ) {

    if ( typeof page == 'undefined' ) page = 1;
    if ( typeof offset == 'undefined' ) offset = 5;

    $.ajax({
        type: 'get',
        data: 'suggestion_id='+suggestion_id+"&page="+page+"&offset="+offset,
        url: '/comments/load',
        success: function(result){
            $("li.suggestion-"+suggestion_id).find(".comments").html( result );
        }
    });
}


$("#submit-suggestion").click(function(e){
    e.preventDefault();
    if ( $("textarea[name='suggestion-text']").val() != '' ) {
        $.ajax({
            type: 'post',
            data: $("#form-suggestion").serialize(),
            dataType: 'json',
            url: '/suggestions/add',
            success: function(result){
                $(".suggest-new").prepend("<div class='alert alert-success'>Kiitos! Ehdotuksesi on otettu vastaan.</div>");
                $("#myModal").modal('hide');
                $("textarea[name='suggestion-text']").val('');
            }
        });
    }
});
